local L = LibStub("AceLocale-3.0"):GetLocale("Talented")
local pcall = pcall
local Talented = Talented

function Talented:OnCommReceived(prefix, message, distribution, sender)
	local name, code = self:Deserialize(message)
	if not name or not code then return end

	local opt = StaticPopupDialogs.TALENTED_CONFIRM_SHARE_TEMPLATE
	if not opt then
		opt = {
			button1 = YES,
			button2 = NO,
			OnAccept = function()
				local res, value, class = pcall(self.StringToTemplate, self, opt.code)
				if res then
					self:ImportFromOther(opt.name, {code = opt.code, class = class})
				else
					self:Print("Invalid template", value)
				end
			end,
			timeout = 0,
			exclusive = 1,
			whileDead = 1,
			interruptCinematic = 1
		}
		StaticPopupDialogs.TALENTED_CONFIRM_SHARE_TEMPLATE = opt
	end

	opt.text = L["Do you want to add the template \"%s\" that %s sent you ?"]:format(name, sender)
	opt.name = ("%s - %s"):format(sender, name)
	opt.code = code

	StaticPopup_Show("TALENTED_CONFIRM_SHARE_TEMPLATE")
end

function Talented:ExportTemplateToUser(name)
	local message = self:Serialize(self.template.name, self:TemplateToString(self.template))
	self:SendCommMessage("Talented", message, "WHISPER", name)
end
